> ## Documentation Index
> Fetch the complete documentation index at: https://doc.extole.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List built campaigns

> Returns campaigns in their fully evaluated (built) runtime form, with all evaluatable fields resolved. Use this when the calling system needs effective component values and settings rather than source definitions. Supports the same filtering as `GET /v2/campaigns`.



## OpenAPI

````yaml /api-reference/management.json get /v2/campaigns/built
openapi: 3.0.1
info:
  description: >-
    Configuration endpoints for the Extole platform: campaigns, components,
    audiences, persons, rewards, reporting, integrations setup, and
    administrative tooling.
  title: Management API
  version: '1.0'
servers:
  - description: Production
    url: https://api.extole.io
security:
  - HEADER: []
  - QUERY: []
  - COOKIE: []
tags:
  - name: Audiences
  - name: Authentication
  - name: Batch Jobs
  - name: Blocks
  - name: Campaigns
  - name: Components
  - name: Components Settings
  - name: Domains
  - name: Email
  - name: Erasure
  - name: Event Streams
  - name: File Validation Monitors
  - name: Optout
  - name: Profiles
  - name: Promotion Links
  - name: Report Schedules
  - name: Report Types
  - name: Reports
  - name: Reward Suppliers
  - name: Security Keys
  - name: Settings
  - name: User Notifications
  - name: User Subscriptions
  - name: Users
  - name: Webhooks
paths:
  /v2/campaigns/built:
    get:
      tags:
        - Campaigns
      summary: List built campaigns
      description: >-
        Returns campaigns in their fully evaluated (built) runtime form, with
        all evaluatable fields resolved. Use this when the calling system needs
        effective component values and settings rather than source definitions.
        Supports the same filtering as `GET /v2/campaigns`.
      operationId: listBuiltCampaigns
      parameters:
        - in: query
          name: version
          schema:
            type: string
        - in: query
          name: reward_supplier_id
          schema:
            type: string
        - in: query
          name: program_label
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/BuiltCampaignResponse'
                type: array
          description: Successful response
        '400':
          content:
            application/json:
              examples:
                binding_error:
                  $ref: '#/components/examples/binding_error'
                campaign_build_failed:
                  $ref: '#/components/examples/campaign_build_failed'
                campaign_concurrent_update:
                  $ref: '#/components/examples/campaign_concurrent_update'
                campaign_has_pending_changes:
                  $ref: '#/components/examples/campaign_has_pending_changes'
                campaign_locked:
                  $ref: '#/components/examples/campaign_locked'
                campaign_version_malformed:
                  $ref: '#/components/examples/campaign_version_malformed'
                controller_state_misconfiguration:
                  $ref: '#/components/examples/controller_state_misconfiguration'
                date_invalid:
                  $ref: '#/components/examples/date_invalid'
                expression_invalid_syntax:
                  $ref: '#/components/examples/expression_invalid_syntax'
                invalid_campaign_id:
                  $ref: '#/components/examples/invalid_campaign_id'
                invalid_campaign_state:
                  $ref: '#/components/examples/invalid_campaign_state'
                invalid_campaign_version:
                  $ref: '#/components/examples/invalid_campaign_version'
                invalid_json:
                  $ref: '#/components/examples/invalid_json'
                invalid_parameter:
                  $ref: '#/components/examples/invalid_parameter'
                lock_missing_lock_types:
                  $ref: '#/components/examples/lock_missing_lock_types'
                missing_request_body:
                  $ref: '#/components/examples/missing_request_body'
                rebuild_campaigns_build_failed:
                  $ref: '#/components/examples/rebuild_campaigns_build_failed'
                unlock_missing_lock_types:
                  $ref: '#/components/examples/unlock_missing_lock_types'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Bad Request
        '401':
          content:
            application/json:
              examples:
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unauthorized
        '402':
          content:
            application/json:
              examples:
                payment_required:
                  $ref: '#/components/examples/payment_required'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Payment Required
        '403':
          content:
            application/json:
              examples:
                access_denied:
                  $ref: '#/components/examples/access_denied'
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
                missing_access_token:
                  $ref: '#/components/examples/missing_access_token'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Forbidden
        '415':
          content:
            application/json:
              examples:
                unsupported_media_type:
                  $ref: '#/components/examples/unsupported_media_type'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unsupported Media Type
        '429':
          content:
            application/json:
              examples:
                too_many_requests:
                  $ref: '#/components/examples/too_many_requests'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Too Many Requests
components:
  schemas:
    BuiltCampaignResponse:
      description: >-
        campaign after buildtime evaluation. Fields `variant_selector` and
        `variants` are already evaluated.
      properties:
        campaign_id:
          type: string
        campaign_locks:
          items:
            enum:
              - DUPLICATE
              - EDIT
            type: string
          type: array
          uniqueItems: true
        campaign_type:
          enum:
            - CONFIGURATION
            - EXTENSION
            - INTEGRATION
            - MARKETING
          type: string
        components:
          items:
            $ref: '#/components/schemas/BuiltCampaignComponentResponse'
          type: array
        description:
          type: string
        end_date:
          $ref: '#/components/schemas/ZonedDateTime'
        flow_steps:
          items:
            $ref: '#/components/schemas/BuiltCampaignFlowStepResponse'
          type: array
        incentive:
          $ref: '#/components/schemas/IncentiveResponse'
        incentive_id:
          type: string
        is_published:
          type: boolean
        labels:
          items:
            $ref: '#/components/schemas/CampaignLabelResponse'
          type: array
        last_published_date:
          $ref: '#/components/schemas/ZonedDateTime'
        name:
          type: string
        parent_version:
          format: int32
          type: integer
        pause_date:
          $ref: '#/components/schemas/ZonedDateTime'
        program_label:
          type: string
        program_type:
          type: string
        start_date:
          $ref: '#/components/schemas/ZonedDateTime'
        state:
          enum:
            - ARCHIVED
            - ENDED
            - LIVE
            - NOT_LAUNCHED
            - PAUSED
            - STOPPED
          type: string
        steps:
          items:
            $ref: '#/components/schemas/BuiltCampaignStepResponse'
          type: array
        stop_date:
          $ref: '#/components/schemas/ZonedDateTime'
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
        theme_name:
          type: string
        updated_date:
          $ref: '#/components/schemas/ZonedDateTime'
        variant_selector:
          $ref: '#/components/schemas/VariantSelectorInBuiltCampaignResponse'
        variants:
          items:
            type: string
          type: array
        version:
          format: int32
          type: integer
      required:
        - campaign_id
        - campaign_locks
        - campaign_type
        - components
        - description
        - end_date
        - flow_steps
        - incentive
        - incentive_id
        - is_published
        - labels
        - last_published_date
        - name
        - parent_version
        - pause_date
        - program_label
        - program_type
        - start_date
        - state
        - steps
        - stop_date
        - tags
        - theme_name
        - updated_date
        - variant_selector
        - variants
        - version
      type: object
    RestExceptionResponse:
      description: Represents the API error response
      properties:
        code:
          description: Specific error code for this error type, documented per endpoint
          type: string
        http_status_code:
          description: >-
            HTTP status code that was returned with this error, useful if client
            get response code
          format: int32
          type: integer
        message:
          description: User readable English description of the error
          type: string
        parameters:
          additionalProperties:
            description: >-
              Attributes related to the error, varies be error code, documented
              per endpoint
            type: object
          description: >-
            Attributes related to the error, varies be error code, documented
            per endpoint
          type: object
        unique_id:
          description: >-
            Unique id associated with this error, useful for discussions with
            Extole
          type: string
      required:
        - code
        - http_status_code
        - message
        - parameters
        - unique_id
      type: object
    BuiltCampaignComponentResponse:
      properties:
        assets:
          items:
            $ref: '#/components/schemas/BuiltComponentAssetResponse'
          type: array
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        created_date:
          $ref: '#/components/schemas/ZonedDateTime'
        description:
          type: string
        display_name:
          type: string
        facets:
          items:
            $ref: '#/components/schemas/CampaignComponentFacetResponse'
          type: array
        id:
          readOnly: true
          type: string
        install:
          $ref: '#/components/schemas/InstallInBuiltCampaignComponentResponse'
        installed_into_socket:
          type: string
        name:
          type: string
        origin:
          $ref: '#/components/schemas/ComponentOriginResponse'
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
        type:
          type: string
        types:
          items:
            type: string
          type: array
        updated_date:
          $ref: '#/components/schemas/ZonedDateTime'
        upload_version:
          type: string
        variables:
          items:
            $ref: '#/components/schemas/BuiltCampaignComponentSettingResponse'
          type: array
        version:
          format: int32
          type: integer
      required:
        - assets
        - component_ids
        - component_references
        - created_date
        - description
        - display_name
        - facets
        - id
        - install
        - installed_into_socket
        - name
        - origin
        - tags
        - type
        - types
        - updated_date
        - upload_version
        - variables
        - version
      type: object
    ZonedDateTime:
      description: >-
        [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6) or
        [RFC 9557](https://datatracker.ietf.org/doc/html/rfc9557#section-4)
        date-time with a numeric [UTC
        offset](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6) and
        an optional [IANA
        time-zone](https://datatracker.ietf.org/doc/html/rfc9557#section-4)
        suffix in square brackets. Precision up to milliseconds.
      example: '2025-10-24T02:00:00-07:00'
      pattern: >-
        ^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d{1,3})?(Z|[+-](?:[01][0-9]|2[0-3]):[0-5][0-9])(\[[^\]]+\])?$
      type: string
    BuiltCampaignFlowStepResponse:
      properties:
        apps:
          items:
            $ref: '#/components/schemas/BuiltCampaignFlowStepAppResponse'
          type: array
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        description:
          type: string
        flow_path:
          type: string
        flow_step_id:
          type: string
        icon_color:
          type: string
        icon_type:
          type: string
        metrics:
          items:
            $ref: '#/components/schemas/BuiltCampaignFlowStepMetricResponse'
          type: array
        name:
          type: string
        sequence:
          type: number
        step_name:
          type: string
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
        words:
          $ref: '#/components/schemas/BuiltCampaignFlowStepWordsResponse'
      required:
        - apps
        - component_ids
        - component_references
        - description
        - flow_path
        - flow_step_id
        - icon_color
        - icon_type
        - metrics
        - name
        - sequence
        - step_name
        - tags
        - words
      type: object
    IncentiveResponse:
      properties:
        id:
          readOnly: true
          type: string
        quality_rules:
          items:
            $ref: '#/components/schemas/QualityRuleResponse'
          type: array
        reward_rules:
          items:
            $ref: '#/components/schemas/RewardRuleResponse'
          type: array
        transition_rules:
          items:
            $ref: '#/components/schemas/TransitionRuleResponse'
          type: array
      required:
        - id
        - quality_rules
        - reward_rules
        - transition_rules
      type: object
    CampaignLabelResponse:
      properties:
        name:
          type: string
        type:
          enum:
            - DATA
            - PROGRAM
          type: string
      type: object
    BuiltCampaignStepResponse:
      discriminator:
        mapping:
          CONTROLLER:
            $ref: '#/components/schemas/BuiltCampaignControllerResponse'
          FRONTEND_CONTROLLER:
            $ref: '#/components/schemas/BuiltCampaignFrontendControllerResponse'
          JOURNEY_ENTRY:
            $ref: '#/components/schemas/BuiltCampaignJourneyEntryResponse'
        propertyName: type
      oneOf:
        - title: CONTROLLER
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignControllerResponse'
        - title: FRONTEND_CONTROLLER
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignFrontendControllerResponse'
        - title: JOURNEY_ENTRY
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignJourneyEntryResponse'
      required:
        - component_ids
        - component_references
        - created_date
        - data
        - enabled
        - id
        - step_builder
        - triggers
        - type
        - updated_date
    VariantSelectorInBuiltCampaignResponse:
      description: >-
        The variant selector as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@runtime:.*
                    type: string
                  - pattern: ^javascript@runtime:.*
                    type: string
              type: string
          description: Literal variant selector
          title: Static Value
        - description: >-
            Handlebars expression with
            [VariantSelectionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/VariantSelectionContext.d.ts).
          example: handlebars@runtime:{{variantSelector}}
          externalDocs:
            description: VariantSelectionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/VariantSelectionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [VariantSelectionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/VariantSelectionContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('variantSelector');}
          externalDocs:
            description: VariantSelectionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/VariantSelectionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    BuiltComponentAssetResponse:
      properties:
        description:
          type: string
        filename:
          type: string
        id:
          readOnly: true
          type: string
        name:
          type: string
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
      required:
        - description
        - filename
        - id
        - name
        - tags
      type: object
    ComponentReferenceResponse:
      properties:
        component_id:
          type: string
        socket_names:
          items:
            type: string
          type: array
      type: object
    CampaignComponentFacetResponse:
      properties:
        name:
          type: string
        value:
          type: string
      type: object
    InstallInBuiltCampaignComponentResponse:
      description: >-
        The install as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal install
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ComponentInstalltimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts).
          example: handlebars@installtime:{{install}}
          externalDocs:
            description: ComponentInstalltimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts
          pattern: ^handlebars@installtime:.*
          title: Installtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ComponentInstalltimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts).
          example: >-
            javascript@installtime:function() { return
            context.getVariableContext().get('install');}
          externalDocs:
            description: ComponentInstalltimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts
          pattern: ^javascript@installtime:.*
          title: Installtime - Javascript
          type: string
    ComponentOriginResponse:
      properties:
        client_id:
          type: string
        component_id:
          type: string
        component_version:
          format: int32
          type: integer
      type: object
    BuiltCampaignComponentSettingResponse:
      discriminator:
        mapping:
          ADMIN_ICON:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsAdminIcon
          AUDIENCE_ID:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsAudienceId
          AUDIENCE_ID_LIST:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsAudienceIdList
          BOOLEAN:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsBoolean
          BROWSER_SIDE_JAVASCRIPT:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsBrowserSideJavascript
          CLIENT_DOMAIN_ID_LIST:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsClientDomainIdList
          CLIENT_KEY:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsClientKey
          CLIENT_KEY_FLOW:
            $ref: '#/components/schemas/BuiltComponentClientKeyFlowVariableResponse'
          COLOR:
            $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsColor'
          COMPONENT_ID:
            $ref: '#/components/schemas/BuiltComponentComponentIdVariableResponse'
          COMPONENT_SETTING_LOOKUP:
            $ref: >-
              #/components/schemas/BuiltComponentComponentSettingLookupVariableResponse
          CSS:
            $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsCss'
          DELAY:
            $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsDelay'
          DELAY_LIST:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsDelayList
          ENUM:
            $ref: '#/components/schemas/BuiltComponentEnumVariableResponse'
          ENUM_LIST:
            $ref: '#/components/schemas/BuiltComponentEnumListVariableResponse'
          EXTOLE_CLIENT_KEY:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsExtoleClientKey
          FONT:
            $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsFont'
          GLOB_COMPONENT_PATH:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsGlobComponentPath
          HTML:
            $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsHtml'
          IMAGE:
            $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsImage'
          INTEGER:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsInteger
          INTEGER_LIST:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsIntegerList
          JSON:
            $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsJson'
          MULTI_SOCKET:
            $ref: '#/components/schemas/BuiltComponentSocketResponseAsMultiSocket'
          PARTNER_ENUM:
            $ref: '#/components/schemas/BuiltComponentPartnerEnumVariableResponse'
          PARTNER_ENUM_LIST:
            $ref: '#/components/schemas/BuiltComponentPartnerEnumListVariableResponse'
          PERSON_KEY_NAME:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsPersonKeyName
          REWARD_SUPPLIER_ID:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsRewardSupplierId
          REWARD_SUPPLIER_ID_LIST:
            $ref: >-
              #/components/schemas/BuiltComponentRewardSupplierIdListVariableResponse
          SOCKET:
            $ref: '#/components/schemas/BuiltComponentSocketResponseAsSocket'
          STRING:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsString
          STRING_LIST:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsStringList
          STRING_MAP:
            $ref: '#/components/schemas/BuiltComponentStringMapVariableResponse'
          URL:
            $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsUrl'
          WEBHOOK_ID:
            $ref: >-
              #/components/schemas/BuiltCampaignComponentVariableResponseAsWebhookId
        propertyName: type
      oneOf:
        - title: ADMIN_ICON
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsAdminIcon
        - title: AUDIENCE_ID
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsAudienceId
        - title: AUDIENCE_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsAudienceIdList
        - title: BOOLEAN
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsBoolean
        - title: BROWSER_SIDE_JAVASCRIPT
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsBrowserSideJavascript
        - title: CLIENT_DOMAIN_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsClientDomainIdList
        - title: CLIENT_KEY
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsClientKey
        - title: CLIENT_KEY_FLOW
          allOf:
            - $ref: '#/components/schemas/BuiltComponentClientKeyFlowVariableResponse'
        - title: COLOR
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsColor
        - title: COMPONENT_ID
          allOf:
            - $ref: '#/components/schemas/BuiltComponentComponentIdVariableResponse'
        - title: COMPONENT_SETTING_LOOKUP
          allOf:
            - $ref: >-
                #/components/schemas/BuiltComponentComponentSettingLookupVariableResponse
        - title: CSS
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsCss'
        - title: DELAY
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsDelay
        - title: DELAY_LIST
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsDelayList
        - title: ENUM
          allOf:
            - $ref: '#/components/schemas/BuiltComponentEnumVariableResponse'
        - title: ENUM_LIST
          allOf:
            - $ref: '#/components/schemas/BuiltComponentEnumListVariableResponse'
        - title: EXTOLE_CLIENT_KEY
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsExtoleClientKey
        - title: FONT
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsFont
        - title: GLOB_COMPONENT_PATH
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsGlobComponentPath
        - title: HTML
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsHtml
        - title: IMAGE
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsImage
        - title: INTEGER
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsInteger
        - title: INTEGER_LIST
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsIntegerList
        - title: JSON
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsJson
        - title: MULTI_SOCKET
          allOf:
            - $ref: '#/components/schemas/BuiltComponentSocketResponseAsMultiSocket'
        - title: PARTNER_ENUM
          allOf:
            - $ref: '#/components/schemas/BuiltComponentPartnerEnumVariableResponse'
        - title: PARTNER_ENUM_LIST
          allOf:
            - $ref: >-
                #/components/schemas/BuiltComponentPartnerEnumListVariableResponse
        - title: PERSON_KEY_NAME
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsPersonKeyName
        - title: REWARD_SUPPLIER_ID
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsRewardSupplierId
        - title: REWARD_SUPPLIER_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/BuiltComponentRewardSupplierIdListVariableResponse
        - title: SOCKET
          allOf:
            - $ref: '#/components/schemas/BuiltComponentSocketResponseAsSocket'
        - title: STRING
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsString
        - title: STRING_LIST
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsStringList
        - title: STRING_MAP
          allOf:
            - $ref: '#/components/schemas/BuiltComponentStringMapVariableResponse'
        - title: URL
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignComponentVariableResponseAsUrl'
        - title: WEBHOOK_ID
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignComponentVariableResponseAsWebhookId
      required:
        - display_name
        - name
        - priority
        - tags
        - type
        - values
    BuiltCampaignFlowStepAppResponse:
      properties:
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        description:
          type: string
        name:
          type: string
        type:
          $ref: '#/components/schemas/BuiltCampaignFlowStepAppTypeResponse'
      required:
        - component_ids
        - component_references
        - description
        - name
        - type
      type: object
    BuiltCampaignFlowStepMetricResponse:
      properties:
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        description:
          nullable: true
          type: string
        expression:
          type: string
        id:
          readOnly: true
          type: string
        name:
          type: string
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
        unit:
          type: string
      required:
        - component_ids
        - component_references
        - description
        - expression
        - id
        - name
        - tags
        - unit
      type: object
    BuiltCampaignFlowStepWordsResponse:
      properties:
        person_counting_name:
          type: string
        plural_noun_name:
          type: string
        rate_name:
          type: string
        singular_noun_name:
          type: string
        verb_name:
          type: string
      type: object
    QualityRuleResponse:
      properties:
        action_types:
          items:
            enum:
              - ANY_CLICK
              - ANY_PROMOTION
              - ANY_PURCHASE
              - ANY_REGISTER
              - ANY_SHARE
              - ANY_SHARE_REWARD
              - GENERIC_ACTION_1
              - GENERIC_ACTION_10
              - GENERIC_ACTION_100
              - GENERIC_ACTION_101
              - GENERIC_ACTION_102
              - GENERIC_ACTION_103
              - GENERIC_ACTION_104
              - GENERIC_ACTION_105
              - GENERIC_ACTION_106
              - GENERIC_ACTION_107
              - GENERIC_ACTION_108
              - GENERIC_ACTION_109
              - GENERIC_ACTION_11
              - GENERIC_ACTION_110
              - GENERIC_ACTION_111
              - GENERIC_ACTION_112
              - GENERIC_ACTION_113
              - GENERIC_ACTION_114
              - GENERIC_ACTION_115
              - GENERIC_ACTION_116
              - GENERIC_ACTION_117
              - GENERIC_ACTION_118
              - GENERIC_ACTION_119
              - GENERIC_ACTION_12
              - GENERIC_ACTION_120
              - GENERIC_ACTION_121
              - GENERIC_ACTION_122
              - GENERIC_ACTION_123
              - GENERIC_ACTION_124
              - GENERIC_ACTION_125
              - GENERIC_ACTION_126
              - GENERIC_ACTION_127
              - GENERIC_ACTION_128
              - GENERIC_ACTION_129
              - GENERIC_ACTION_13
              - GENERIC_ACTION_130
              - GENERIC_ACTION_131
              - GENERIC_ACTION_132
              - GENERIC_ACTION_133
              - GENERIC_ACTION_134
              - GENERIC_ACTION_135
              - GENERIC_ACTION_136
              - GENERIC_ACTION_137
              - GENERIC_ACTION_138
              - GENERIC_ACTION_139
              - GENERIC_ACTION_14
              - GENERIC_ACTION_140
              - GENERIC_ACTION_141
              - GENERIC_ACTION_142
              - GENERIC_ACTION_143
              - GENERIC_ACTION_144
              - GENERIC_ACTION_145
              - GENERIC_ACTION_146
              - GENERIC_ACTION_147
              - GENERIC_ACTION_148
              - GENERIC_ACTION_149
              - GENERIC_ACTION_15
              - GENERIC_ACTION_150
              - GENERIC_ACTION_151
              - GENERIC_ACTION_152
              - GENERIC_ACTION_153
              - GENERIC_ACTION_154
              - GENERIC_ACTION_155
              - GENERIC_ACTION_156
              - GENERIC_ACTION_157
              - GENERIC_ACTION_158
              - GENERIC_ACTION_159
              - GENERIC_ACTION_16
              - GENERIC_ACTION_160
              - GENERIC_ACTION_161
              - GENERIC_ACTION_162
              - GENERIC_ACTION_163
              - GENERIC_ACTION_164
              - GENERIC_ACTION_165
              - GENERIC_ACTION_166
              - GENERIC_ACTION_167
              - GENERIC_ACTION_168
              - GENERIC_ACTION_169
              - GENERIC_ACTION_17
              - GENERIC_ACTION_170
              - GENERIC_ACTION_171
              - GENERIC_ACTION_172
              - GENERIC_ACTION_173
              - GENERIC_ACTION_174
              - GENERIC_ACTION_175
              - GENERIC_ACTION_176
              - GENERIC_ACTION_177
              - GENERIC_ACTION_178
              - GENERIC_ACTION_179
              - GENERIC_ACTION_18
              - GENERIC_ACTION_180
              - GENERIC_ACTION_181
              - GENERIC_ACTION_182
              - GENERIC_ACTION_183
              - GENERIC_ACTION_184
              - GENERIC_ACTION_185
              - GENERIC_ACTION_186
              - GENERIC_ACTION_187
              - GENERIC_ACTION_188
              - GENERIC_ACTION_189
              - GENERIC_ACTION_19
              - GENERIC_ACTION_190
              - GENERIC_ACTION_191
              - GENERIC_ACTION_192
              - GENERIC_ACTION_193
              - GENERIC_ACTION_194
              - GENERIC_ACTION_195
              - GENERIC_ACTION_196
              - GENERIC_ACTION_197
              - GENERIC_ACTION_198
              - GENERIC_ACTION_199
              - GENERIC_ACTION_2
              - GENERIC_ACTION_20
              - GENERIC_ACTION_200
              - GENERIC_ACTION_21
              - GENERIC_ACTION_22
              - GENERIC_ACTION_23
              - GENERIC_ACTION_24
              - GENERIC_ACTION_25
              - GENERIC_ACTION_26
              - GENERIC_ACTION_27
              - GENERIC_ACTION_28
              - GENERIC_ACTION_29
              - GENERIC_ACTION_3
              - GENERIC_ACTION_30
              - GENERIC_ACTION_31
              - GENERIC_ACTION_32
              - GENERIC_ACTION_33
              - GENERIC_ACTION_34
              - GENERIC_ACTION_35
              - GENERIC_ACTION_36
              - GENERIC_ACTION_37
              - GENERIC_ACTION_38
              - GENERIC_ACTION_39
              - GENERIC_ACTION_4
              - GENERIC_ACTION_40
              - GENERIC_ACTION_41
              - GENERIC_ACTION_42
              - GENERIC_ACTION_43
              - GENERIC_ACTION_44
              - GENERIC_ACTION_45
              - GENERIC_ACTION_46
              - GENERIC_ACTION_47
              - GENERIC_ACTION_48
              - GENERIC_ACTION_49
              - GENERIC_ACTION_5
              - GENERIC_ACTION_50
              - GENERIC_ACTION_51
              - GENERIC_ACTION_52
              - GENERIC_ACTION_53
              - GENERIC_ACTION_54
              - GENERIC_ACTION_55
              - GENERIC_ACTION_56
              - GENERIC_ACTION_57
              - GENERIC_ACTION_58
              - GENERIC_ACTION_59
              - GENERIC_ACTION_6
              - GENERIC_ACTION_60
              - GENERIC_ACTION_61
              - GENERIC_ACTION_62
              - GENERIC_ACTION_63
              - GENERIC_ACTION_64
              - GENERIC_ACTION_65
              - GENERIC_ACTION_66
              - GENERIC_ACTION_67
              - GENERIC_ACTION_68
              - GENERIC_ACTION_69
              - GENERIC_ACTION_7
              - GENERIC_ACTION_70
              - GENERIC_ACTION_71
              - GENERIC_ACTION_72
              - GENERIC_ACTION_73
              - GENERIC_ACTION_74
              - GENERIC_ACTION_75
              - GENERIC_ACTION_76
              - GENERIC_ACTION_77
              - GENERIC_ACTION_78
              - GENERIC_ACTION_79
              - GENERIC_ACTION_8
              - GENERIC_ACTION_80
              - GENERIC_ACTION_81
              - GENERIC_ACTION_82
              - GENERIC_ACTION_83
              - GENERIC_ACTION_84
              - GENERIC_ACTION_85
              - GENERIC_ACTION_86
              - GENERIC_ACTION_87
              - GENERIC_ACTION_88
              - GENERIC_ACTION_89
              - GENERIC_ACTION_9
              - GENERIC_ACTION_90
              - GENERIC_ACTION_91
              - GENERIC_ACTION_92
              - GENERIC_ACTION_93
              - GENERIC_ACTION_94
              - GENERIC_ACTION_95
              - GENERIC_ACTION_96
              - GENERIC_ACTION_97
              - GENERIC_ACTION_98
              - GENERIC_ACTION_99
              - THEME_GENERIC_ACTION_1
              - THEME_GENERIC_ACTION_10
              - THEME_GENERIC_ACTION_11
              - THEME_GENERIC_ACTION_12
              - THEME_GENERIC_ACTION_13
              - THEME_GENERIC_ACTION_14
              - THEME_GENERIC_ACTION_15
              - THEME_GENERIC_ACTION_16
              - THEME_GENERIC_ACTION_17
              - THEME_GENERIC_ACTION_18
              - THEME_GENERIC_ACTION_19
              - THEME_GENERIC_ACTION_2
              - THEME_GENERIC_ACTION_20
              - THEME_GENERIC_ACTION_21
              - THEME_GENERIC_ACTION_22
              - THEME_GENERIC_ACTION_23
              - THEME_GENERIC_ACTION_24
              - THEME_GENERIC_ACTION_25
              - THEME_GENERIC_ACTION_26
              - THEME_GENERIC_ACTION_27
              - THEME_GENERIC_ACTION_28
              - THEME_GENERIC_ACTION_29
              - THEME_GENERIC_ACTION_3
              - THEME_GENERIC_ACTION_30
              - THEME_GENERIC_ACTION_4
              - THEME_GENERIC_ACTION_5
              - THEME_GENERIC_ACTION_6
              - THEME_GENERIC_ACTION_7
              - THEME_GENERIC_ACTION_8
              - THEME_GENERIC_ACTION_9
            type: string
          type: array
          uniqueItems: true
        enabled:
          type: boolean
        id:
          readOnly: true
          type: string
        properties:
          additionalProperties:
            items:
              type: string
            type: array
          type: object
        rule_type:
          enum:
            - BAD_COUNTRY
            - BLACKLIST_DOMAIN
            - BLACKLIST_REFERER_HEADER
            - BLOCKED
            - BOT_FILTER
            - EVENT_SPEED
            - EXISTING_CUSTOMER
            - FRIENDS_OF_ADVOCATE_CLICK_LIMIT
            - FRIENDS_OF_ADVOCATE_CONVERSION_LIMIT
            - FRIENDS_OF_ADVOCATE_REGISTRATION_LIMIT
            - GENERIC
            - GLOBAL_BLOCK
            - IP_FILTER
            - PERSON_DATA
            - PREVIEW
            - PROFILE_DISPLACED
            - RECENT_CUSTOMER
            - RECIPIENT_LIMIT
            - REFERRAL_AGE
            - REFERRAL_CAP
            - SAME_IP
            - SELF_REFERRAL
            - SHARE_COUNT_LIMIT
            - SIMILAR_FRIEND_ADVOCATE_EMAIL
            - SPAM_MESSAGE
            - VALID_EMAIL
          type: string
      required:
        - action_types
        - enabled
        - id
        - properties
        - rule_type
      type: object
    RewardRuleResponse:
      properties:
        count_rewards_based_on_partner_user_id:
          nullable: true
          type: boolean
        data_attribute_matcher_type:
          enum:
            - EXACT
            - REGEX
          nullable: true
          type: string
        data_attribute_name:
          nullable: true
          type: string
        data_attribute_value:
          nullable: true
          type: string
        expression:
          $ref: '#/components/schemas/RewardRuleExpression'
        id:
          readOnly: true
          type: string
        is_email_required:
          type: boolean
        is_referral_loop_allowed:
          type: boolean
        is_unique_friend_required:
          type: boolean
        min_cart_value:
          type: number
        referrals_per_reward:
          format: int32
          type: integer
        reward_count_limit:
          format: int32
          type: integer
        reward_count_since_days:
          format: int32
          nullable: true
          type: integer
        reward_count_since_month:
          format: int32
          nullable: true
          type: integer
        reward_every_x_friend_actions:
          format: int32
          nullable: true
          type: integer
        reward_slots:
          items:
            type: string
          type: array
          uniqueItems: true
        reward_supplier_id:
          type: string
        reward_value_limit:
          type: number
        reward_value_since_days:
          format: int32
          nullable: true
          type: integer
        reward_value_since_month:
          format: int32
          nullable: true
          type: integer
        rewardee:
          enum:
            - ADVOCATE
            - FRIEND
          type: string
        trigger_action_type:
          enum:
            - ANY_CLICK
            - ANY_PROMOTION
            - ANY_PURCHASE
            - ANY_REGISTER
            - ANY_SHARE
            - ANY_SHARE_REWARD
            - GENERIC_ACTION_1
            - GENERIC_ACTION_10
            - GENERIC_ACTION_100
            - GENERIC_ACTION_101
            - GENERIC_ACTION_102
            - GENERIC_ACTION_103
            - GENERIC_ACTION_104
            - GENERIC_ACTION_105
            - GENERIC_ACTION_106
            - GENERIC_ACTION_107
            - GENERIC_ACTION_108
            - GENERIC_ACTION_109
            - GENERIC_ACTION_11
            - GENERIC_ACTION_110
            - GENERIC_ACTION_111
            - GENERIC_ACTION_112
            - GENERIC_ACTION_113
            - GENERIC_ACTION_114
            - GENERIC_ACTION_115
            - GENERIC_ACTION_116
            - GENERIC_ACTION_117
            - GENERIC_ACTION_118
            - GENERIC_ACTION_119
            - GENERIC_ACTION_12
            - GENERIC_ACTION_120
            - GENERIC_ACTION_121
            - GENERIC_ACTION_122
            - GENERIC_ACTION_123
            - GENERIC_ACTION_124
            - GENERIC_ACTION_125
            - GENERIC_ACTION_126
            - GENERIC_ACTION_127
            - GENERIC_ACTION_128
            - GENERIC_ACTION_129
            - GENERIC_ACTION_13
            - GENERIC_ACTION_130
            - GENERIC_ACTION_131
            - GENERIC_ACTION_132
            - GENERIC_ACTION_133
            - GENERIC_ACTION_134
            - GENERIC_ACTION_135
            - GENERIC_ACTION_136
            - GENERIC_ACTION_137
            - GENERIC_ACTION_138
            - GENERIC_ACTION_139
            - GENERIC_ACTION_14
            - GENERIC_ACTION_140
            - GENERIC_ACTION_141
            - GENERIC_ACTION_142
            - GENERIC_ACTION_143
            - GENERIC_ACTION_144
            - GENERIC_ACTION_145
            - GENERIC_ACTION_146
            - GENERIC_ACTION_147
            - GENERIC_ACTION_148
            - GENERIC_ACTION_149
            - GENERIC_ACTION_15
            - GENERIC_ACTION_150
            - GENERIC_ACTION_151
            - GENERIC_ACTION_152
            - GENERIC_ACTION_153
            - GENERIC_ACTION_154
            - GENERIC_ACTION_155
            - GENERIC_ACTION_156
            - GENERIC_ACTION_157
            - GENERIC_ACTION_158
            - GENERIC_ACTION_159
            - GENERIC_ACTION_16
            - GENERIC_ACTION_160
            - GENERIC_ACTION_161
            - GENERIC_ACTION_162
            - GENERIC_ACTION_163
            - GENERIC_ACTION_164
            - GENERIC_ACTION_165
            - GENERIC_ACTION_166
            - GENERIC_ACTION_167
            - GENERIC_ACTION_168
            - GENERIC_ACTION_169
            - GENERIC_ACTION_17
            - GENERIC_ACTION_170
            - GENERIC_ACTION_171
            - GENERIC_ACTION_172
            - GENERIC_ACTION_173
            - GENERIC_ACTION_174
            - GENERIC_ACTION_175
            - GENERIC_ACTION_176
            - GENERIC_ACTION_177
            - GENERIC_ACTION_178
            - GENERIC_ACTION_179
            - GENERIC_ACTION_18
            - GENERIC_ACTION_180
            - GENERIC_ACTION_181
            - GENERIC_ACTION_182
            - GENERIC_ACTION_183
            - GENERIC_ACTION_184
            - GENERIC_ACTION_185
            - GENERIC_ACTION_186
            - GENERIC_ACTION_187
            - GENERIC_ACTION_188
            - GENERIC_ACTION_189
            - GENERIC_ACTION_19
            - GENERIC_ACTION_190
            - GENERIC_ACTION_191
            - GENERIC_ACTION_192
            - GENERIC_ACTION_193
            - GENERIC_ACTION_194
            - GENERIC_ACTION_195
            - GENERIC_ACTION_196
            - GENERIC_ACTION_197
            - GENERIC_ACTION_198
            - GENERIC_ACTION_199
            - GENERIC_ACTION_2
            - GENERIC_ACTION_20
            - GENERIC_ACTION_200
            - GENERIC_ACTION_21
            - GENERIC_ACTION_22
            - GENERIC_ACTION_23
            - GENERIC_ACTION_24
            - GENERIC_ACTION_25
            - GENERIC_ACTION_26
            - GENERIC_ACTION_27
            - GENERIC_ACTION_28
            - GENERIC_ACTION_29
            - GENERIC_ACTION_3
            - GENERIC_ACTION_30
            - GENERIC_ACTION_31
            - GENERIC_ACTION_32
            - GENERIC_ACTION_33
            - GENERIC_ACTION_34
            - GENERIC_ACTION_35
            - GENERIC_ACTION_36
            - GENERIC_ACTION_37
            - GENERIC_ACTION_38
            - GENERIC_ACTION_39
            - GENERIC_ACTION_4
            - GENERIC_ACTION_40
            - GENERIC_ACTION_41
            - GENERIC_ACTION_42
            - GENERIC_ACTION_43
            - GENERIC_ACTION_44
            - GENERIC_ACTION_45
            - GENERIC_ACTION_46
            - GENERIC_ACTION_47
            - GENERIC_ACTION_48
            - GENERIC_ACTION_49
            - GENERIC_ACTION_5
            - GENERIC_ACTION_50
            - GENERIC_ACTION_51
            - GENERIC_ACTION_52
            - GENERIC_ACTION_53
            - GENERIC_ACTION_54
            - GENERIC_ACTION_55
            - GENERIC_ACTION_56
            - GENERIC_ACTION_57
            - GENERIC_ACTION_58
            - GENERIC_ACTION_59
            - GENERIC_ACTION_6
            - GENERIC_ACTION_60
            - GENERIC_ACTION_61
            - GENERIC_ACTION_62
            - GENERIC_ACTION_63
            - GENERIC_ACTION_64
            - GENERIC_ACTION_65
            - GENERIC_ACTION_66
            - GENERIC_ACTION_67
            - GENERIC_ACTION_68
            - GENERIC_ACTION_69
            - GENERIC_ACTION_7
            - GENERIC_ACTION_70
            - GENERIC_ACTION_71
            - GENERIC_ACTION_72
            - GENERIC_ACTION_73
            - GENERIC_ACTION_74
            - GENERIC_ACTION_75
            - GENERIC_ACTION_76
            - GENERIC_ACTION_77
            - GENERIC_ACTION_78
            - GENERIC_ACTION_79
            - GENERIC_ACTION_8
            - GENERIC_ACTION_80
            - GENERIC_ACTION_81
            - GENERIC_ACTION_82
            - GENERIC_ACTION_83
            - GENERIC_ACTION_84
            - GENERIC_ACTION_85
            - GENERIC_ACTION_86
            - GENERIC_ACTION_87
            - GENERIC_ACTION_88
            - GENERIC_ACTION_89
            - GENERIC_ACTION_9
            - GENERIC_ACTION_90
            - GENERIC_ACTION_91
            - GENERIC_ACTION_92
            - GENERIC_ACTION_93
            - GENERIC_ACTION_94
            - GENERIC_ACTION_95
            - GENERIC_ACTION_96
            - GENERIC_ACTION_97
            - GENERIC_ACTION_98
            - GENERIC_ACTION_99
            - THEME_GENERIC_ACTION_1
            - THEME_GENERIC_ACTION_10
            - THEME_GENERIC_ACTION_11
            - THEME_GENERIC_ACTION_12
            - THEME_GENERIC_ACTION_13
            - THEME_GENERIC_ACTION_14
            - THEME_GENERIC_ACTION_15
            - THEME_GENERIC_ACTION_16
            - THEME_GENERIC_ACTION_17
            - THEME_GENERIC_ACTION_18
            - THEME_GENERIC_ACTION_19
            - THEME_GENERIC_ACTION_2
            - THEME_GENERIC_ACTION_20
            - THEME_GENERIC_ACTION_21
            - THEME_GENERIC_ACTION_22
            - THEME_GENERIC_ACTION_23
            - THEME_GENERIC_ACTION_24
            - THEME_GENERIC_ACTION_25
            - THEME_GENERIC_ACTION_26
            - THEME_GENERIC_ACTION_27
            - THEME_GENERIC_ACTION_28
            - THEME_GENERIC_ACTION_29
            - THEME_GENERIC_ACTION_3
            - THEME_GENERIC_ACTION_30
            - THEME_GENERIC_ACTION_4
            - THEME_GENERIC_ACTION_5
            - THEME_GENERIC_ACTION_6
            - THEME_GENERIC_ACTION_7
            - THEME_GENERIC_ACTION_8
            - THEME_GENERIC_ACTION_9
          type: string
      required:
        - count_rewards_based_on_partner_user_id
        - data_attribute_matcher_type
        - data_attribute_name
        - data_attribute_value
        - expression
        - id
        - is_email_required
        - is_referral_loop_allowed
        - is_unique_friend_required
        - min_cart_value
        - referrals_per_reward
        - reward_count_limit
        - reward_count_since_days
        - reward_count_since_month
        - reward_every_x_friend_actions
        - reward_slots
        - reward_supplier_id
        - reward_value_limit
        - reward_value_since_days
        - reward_value_since_month
        - rewardee
        - trigger_action_type
      type: object
    TransitionRuleResponse:
      properties:
        action_type:
          enum:
            - ANY_CLICK
            - ANY_PROMOTION
            - ANY_PURCHASE
            - ANY_REGISTER
            - ANY_SHARE
            - ANY_SHARE_REWARD
            - GENERIC_ACTION_1
            - GENERIC_ACTION_10
            - GENERIC_ACTION_100
            - GENERIC_ACTION_101
            - GENERIC_ACTION_102
            - GENERIC_ACTION_103
            - GENERIC_ACTION_104
            - GENERIC_ACTION_105
            - GENERIC_ACTION_106
            - GENERIC_ACTION_107
            - GENERIC_ACTION_108
            - GENERIC_ACTION_109
            - GENERIC_ACTION_11
            - GENERIC_ACTION_110
            - GENERIC_ACTION_111
            - GENERIC_ACTION_112
            - GENERIC_ACTION_113
            - GENERIC_ACTION_114
            - GENERIC_ACTION_115
            - GENERIC_ACTION_116
            - GENERIC_ACTION_117
            - GENERIC_ACTION_118
            - GENERIC_ACTION_119
            - GENERIC_ACTION_12
            - GENERIC_ACTION_120
            - GENERIC_ACTION_121
            - GENERIC_ACTION_122
            - GENERIC_ACTION_123
            - GENERIC_ACTION_124
            - GENERIC_ACTION_125
            - GENERIC_ACTION_126
            - GENERIC_ACTION_127
            - GENERIC_ACTION_128
            - GENERIC_ACTION_129
            - GENERIC_ACTION_13
            - GENERIC_ACTION_130
            - GENERIC_ACTION_131
            - GENERIC_ACTION_132
            - GENERIC_ACTION_133
            - GENERIC_ACTION_134
            - GENERIC_ACTION_135
            - GENERIC_ACTION_136
            - GENERIC_ACTION_137
            - GENERIC_ACTION_138
            - GENERIC_ACTION_139
            - GENERIC_ACTION_14
            - GENERIC_ACTION_140
            - GENERIC_ACTION_141
            - GENERIC_ACTION_142
            - GENERIC_ACTION_143
            - GENERIC_ACTION_144
            - GENERIC_ACTION_145
            - GENERIC_ACTION_146
            - GENERIC_ACTION_147
            - GENERIC_ACTION_148
            - GENERIC_ACTION_149
            - GENERIC_ACTION_15
            - GENERIC_ACTION_150
            - GENERIC_ACTION_151
            - GENERIC_ACTION_152
            - GENERIC_ACTION_153
            - GENERIC_ACTION_154
            - GENERIC_ACTION_155
            - GENERIC_ACTION_156
            - GENERIC_ACTION_157
            - GENERIC_ACTION_158
            - GENERIC_ACTION_159
            - GENERIC_ACTION_16
            - GENERIC_ACTION_160
            - GENERIC_ACTION_161
            - GENERIC_ACTION_162
            - GENERIC_ACTION_163
            - GENERIC_ACTION_164
            - GENERIC_ACTION_165
            - GENERIC_ACTION_166
            - GENERIC_ACTION_167
            - GENERIC_ACTION_168
            - GENERIC_ACTION_169
            - GENERIC_ACTION_17
            - GENERIC_ACTION_170
            - GENERIC_ACTION_171
            - GENERIC_ACTION_172
            - GENERIC_ACTION_173
            - GENERIC_ACTION_174
            - GENERIC_ACTION_175
            - GENERIC_ACTION_176
            - GENERIC_ACTION_177
            - GENERIC_ACTION_178
            - GENERIC_ACTION_179
            - GENERIC_ACTION_18
            - GENERIC_ACTION_180
            - GENERIC_ACTION_181
            - GENERIC_ACTION_182
            - GENERIC_ACTION_183
            - GENERIC_ACTION_184
            - GENERIC_ACTION_185
            - GENERIC_ACTION_186
            - GENERIC_ACTION_187
            - GENERIC_ACTION_188
            - GENERIC_ACTION_189
            - GENERIC_ACTION_19
            - GENERIC_ACTION_190
            - GENERIC_ACTION_191
            - GENERIC_ACTION_192
            - GENERIC_ACTION_193
            - GENERIC_ACTION_194
            - GENERIC_ACTION_195
            - GENERIC_ACTION_196
            - GENERIC_ACTION_197
            - GENERIC_ACTION_198
            - GENERIC_ACTION_199
            - GENERIC_ACTION_2
            - GENERIC_ACTION_20
            - GENERIC_ACTION_200
            - GENERIC_ACTION_21
            - GENERIC_ACTION_22
            - GENERIC_ACTION_23
            - GENERIC_ACTION_24
            - GENERIC_ACTION_25
            - GENERIC_ACTION_26
            - GENERIC_ACTION_27
            - GENERIC_ACTION_28
            - GENERIC_ACTION_29
            - GENERIC_ACTION_3
            - GENERIC_ACTION_30
            - GENERIC_ACTION_31
            - GENERIC_ACTION_32
            - GENERIC_ACTION_33
            - GENERIC_ACTION_34
            - GENERIC_ACTION_35
            - GENERIC_ACTION_36
            - GENERIC_ACTION_37
            - GENERIC_ACTION_38
            - GENERIC_ACTION_39
            - GENERIC_ACTION_4
            - GENERIC_ACTION_40
            - GENERIC_ACTION_41
            - GENERIC_ACTION_42
            - GENERIC_ACTION_43
            - GENERIC_ACTION_44
            - GENERIC_ACTION_45
            - GENERIC_ACTION_46
            - GENERIC_ACTION_47
            - GENERIC_ACTION_48
            - GENERIC_ACTION_49
            - GENERIC_ACTION_5
            - GENERIC_ACTION_50
            - GENERIC_ACTION_51
            - GENERIC_ACTION_52
            - GENERIC_ACTION_53
            - GENERIC_ACTION_54
            - GENERIC_ACTION_55
            - GENERIC_ACTION_56
            - GENERIC_ACTION_57
            - GENERIC_ACTION_58
            - GENERIC_ACTION_59
            - GENERIC_ACTION_6
            - GENERIC_ACTION_60
            - GENERIC_ACTION_61
            - GENERIC_ACTION_62
            - GENERIC_ACTION_63
            - GENERIC_ACTION_64
            - GENERIC_ACTION_65
            - GENERIC_ACTION_66
            - GENERIC_ACTION_67
            - GENERIC_ACTION_68
            - GENERIC_ACTION_69
            - GENERIC_ACTION_7
            - GENERIC_ACTION_70
            - GENERIC_ACTION_71
            - GENERIC_ACTION_72
            - GENERIC_ACTION_73
            - GENERIC_ACTION_74
            - GENERIC_ACTION_75
            - GENERIC_ACTION_76
            - GENERIC_ACTION_77
            - GENERIC_ACTION_78
            - GENERIC_ACTION_79
            - GENERIC_ACTION_8
            - GENERIC_ACTION_80
            - GENERIC_ACTION_81
            - GENERIC_ACTION_82
            - GENERIC_ACTION_83
            - GENERIC_ACTION_84
            - GENERIC_ACTION_85
            - GENERIC_ACTION_86
            - GENERIC_ACTION_87
            - GENERIC_ACTION_88
            - GENERIC_ACTION_89
            - GENERIC_ACTION_9
            - GENERIC_ACTION_90
            - GENERIC_ACTION_91
            - GENERIC_ACTION_92
            - GENERIC_ACTION_93
            - GENERIC_ACTION_94
            - GENERIC_ACTION_95
            - GENERIC_ACTION_96
            - GENERIC_ACTION_97
            - GENERIC_ACTION_98
            - GENERIC_ACTION_99
            - THEME_GENERIC_ACTION_1
            - THEME_GENERIC_ACTION_10
            - THEME_GENERIC_ACTION_11
            - THEME_GENERIC_ACTION_12
            - THEME_GENERIC_ACTION_13
            - THEME_GENERIC_ACTION_14
            - THEME_GENERIC_ACTION_15
            - THEME_GENERIC_ACTION_16
            - THEME_GENERIC_ACTION_17
            - THEME_GENERIC_ACTION_18
            - THEME_GENERIC_ACTION_19
            - THEME_GENERIC_ACTION_2
            - THEME_GENERIC_ACTION_20
            - THEME_GENERIC_ACTION_21
            - THEME_GENERIC_ACTION_22
            - THEME_GENERIC_ACTION_23
            - THEME_GENERIC_ACTION_24
            - THEME_GENERIC_ACTION_25
            - THEME_GENERIC_ACTION_26
            - THEME_GENERIC_ACTION_27
            - THEME_GENERIC_ACTION_28
            - THEME_GENERIC_ACTION_29
            - THEME_GENERIC_ACTION_3
            - THEME_GENERIC_ACTION_30
            - THEME_GENERIC_ACTION_4
            - THEME_GENERIC_ACTION_5
            - THEME_GENERIC_ACTION_6
            - THEME_GENERIC_ACTION_7
            - THEME_GENERIC_ACTION_8
            - THEME_GENERIC_ACTION_9
          type: string
        approve_high_quality:
          type: boolean
        approve_low_quality:
          type: boolean
        transition_period_milliseconds:
          format: int64
          type: integer
        transition_rule_id:
          type: string
      required:
        - action_type
        - approve_high_quality
        - approve_low_quality
        - transition_period_milliseconds
        - transition_rule_id
      type: object
    BuiltCampaignControllerResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignStepResponseBase'
        - properties:
            actions:
              items:
                $ref: '#/components/schemas/BuiltCampaignControllerActionResponse'
              type: array
            aliases:
              items:
                type: string
              type: array
            controller_id:
              type: string
            enabled_on_states:
              items:
                enum:
                  - ARCHIVED
                  - ENDED
                  - LIVE
                  - NOT_LAUNCHED
                  - PAUSED
                  - STOPPED
                type: string
              type: array
              uniqueItems: true
            id:
              readOnly: true
              type: string
            journey_names:
              items:
                type: string
              type: array
              uniqueItems: true
            name:
              type: string
            scope:
              enum:
                - CLIENT
                - PRIVATE
                - PUBLIC
              type: string
            selectors:
              items:
                enum:
                  - BEST_REFERRAL
                  - BEST_REFERRAL_SAME_PROGRAM
                  - MATCHING_CAMPAIGN
                  - TARGET
                type: string
              type: array
            send_policy:
              enum:
                - ALL
                - FIRST_ONLY
              type: string
            type:
              enum:
                - CONTROLLER
              type: string
          type: object
      required:
        - actions
        - aliases
        - component_ids
        - component_references
        - controller_id
        - created_date
        - data
        - enabled
        - enabled_on_states
        - id
        - journey_names
        - name
        - scope
        - selectors
        - send_policy
        - step_builder
        - triggers
        - type
        - updated_date
      type: object
      title: CONTROLLER
    BuiltCampaignFrontendControllerResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignStepResponseBase'
        - properties:
            actions:
              items:
                $ref: '#/components/schemas/BuiltCampaignControllerActionResponse'
              type: array
            aliases:
              items:
                type: string
              type: array
            category:
              type: string
            enabled_on_states:
              items:
                enum:
                  - ARCHIVED
                  - ENDED
                  - LIVE
                  - NOT_LAUNCHED
                  - PAUSED
                  - STOPPED
                type: string
              type: array
              uniqueItems: true
            id:
              readOnly: true
              type: string
            journey_names:
              items:
                type: string
              type: array
              uniqueItems: true
            name:
              type: string
            scope:
              enum:
                - CLIENT
                - PRIVATE
                - PUBLIC
              type: string
            send_policy:
              enum:
                - ALL
                - FIRST_ONLY
              type: string
            type:
              enum:
                - FRONTEND_CONTROLLER
              type: string
          type: object
      required:
        - actions
        - aliases
        - category
        - component_ids
        - component_references
        - created_date
        - data
        - enabled
        - enabled_on_states
        - id
        - journey_names
        - name
        - scope
        - send_policy
        - step_builder
        - triggers
        - type
        - updated_date
      type: object
      title: FRONTEND_CONTROLLER
    BuiltCampaignJourneyEntryResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignStepResponseBase'
        - properties:
            id:
              readOnly: true
              type: string
            journey_name:
              type: string
            key:
              $ref: '#/components/schemas/BuiltJourneyKeyResponse'
            priority:
              $ref: '#/components/schemas/DeweyDecimal'
            type:
              enum:
                - JOURNEY_ENTRY
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - created_date
        - data
        - enabled
        - id
        - journey_name
        - key
        - priority
        - step_builder
        - triggers
        - type
        - updated_date
      type: object
      title: JOURNEY_ENTRY
    BuiltCampaignComponentVariableResponseAsAdminIcon:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - ADMIN_ICON
              type: string
          type: object
      type: object
      title: ADMIN_ICON
    BuiltCampaignComponentVariableResponseAsAudienceId:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - AUDIENCE_ID
              type: string
          type: object
      type: object
      title: AUDIENCE_ID
    BuiltCampaignComponentVariableResponseAsAudienceIdList:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - AUDIENCE_ID_LIST
              type: string
          type: object
      type: object
      title: AUDIENCE_ID_LIST
    BuiltCampaignComponentVariableResponseAsBoolean:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - BOOLEAN
              type: string
          type: object
      type: object
      title: BOOLEAN
    BuiltCampaignComponentVariableResponseAsBrowserSideJavascript:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - BROWSER_SIDE_JAVASCRIPT
              type: string
          type: object
      type: object
      title: BROWSER_SIDE_JAVASCRIPT
    BuiltCampaignComponentVariableResponseAsClientDomainIdList:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - CLIENT_DOMAIN_ID_LIST
              type: string
          type: object
      type: object
      title: CLIENT_DOMAIN_ID_LIST
    BuiltCampaignComponentVariableResponseAsClientKey:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - CLIENT_KEY
              type: string
          type: object
      type: object
      title: CLIENT_KEY
    BuiltComponentClientKeyFlowVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            authorization_url:
              type: string
            client_secret_key_id:
              type: string
            description:
              type: string
            redirect_url:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - CLIENT_KEY_FLOW
              type: string
          type: object
      required:
        - authorization_url
        - client_secret_key_id
        - description
        - display_name
        - name
        - priority
        - redirect_url
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
      type: object
      title: CLIENT_KEY_FLOW
    BuiltCampaignComponentVariableResponseAsColor:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - COLOR
              type: string
          type: object
      type: object
      title: COLOR
    BuiltComponentComponentIdVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            filter:
              $ref: '#/components/schemas/ComponentIdFilterResponse'
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - COMPONENT_ID
              type: string
          type: object
      required:
        - description
        - display_name
        - filter
        - name
        - priority
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
      type: object
      title: COMPONENT_ID
    BuiltComponentComponentSettingLookupVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            capture_settings:
              items:
                type: string
              type: array
            captured_setting_values_description:
              type: string
            description:
              type: string
            filters:
              items:
                $ref: '#/components/schemas/SettingFilterResponse'
              type: array
            matching_filters:
              items:
                $ref: '#/components/schemas/SettingFilterResponse'
              type: array
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - COMPONENT_SETTING_LOOKUP
              type: string
          type: object
      required:
        - capture_settings
        - captured_setting_values_description
        - description
        - display_name
        - filters
        - matching_filters
        - name
        - priority
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
      type: object
      title: COMPONENT_SETTING_LOOKUP
    BuiltCampaignComponentVariableResponseAsCss:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - CSS
              type: string
          type: object
      type: object
      title: CSS
    BuiltCampaignComponentVariableResponseAsDelay:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - DELAY
              type: string
          type: object
      type: object
      title: DELAY
    BuiltCampaignComponentVariableResponseAsDelayList:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - DELAY_LIST
              type: string
          type: object
      type: object
      title: DELAY_LIST
    BuiltComponentEnumVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            allowed_values:
              items:
                type: string
              type: array
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - ENUM
              type: string
          type: object
      required:
        - allowed_values
        - description
        - display_name
        - name
        - priority
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
      type: object
      title: ENUM
    BuiltComponentEnumListVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            allowed_values:
              items:
                type: string
              type: array
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - ENUM_LIST
              type: string
          type: object
      required:
        - allowed_values
        - description
        - display_name
        - name
        - priority
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
      type: object
      title: ENUM_LIST
    BuiltCampaignComponentVariableResponseAsExtoleClientKey:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - EXTOLE_CLIENT_KEY
              type: string
          type: object
      type: object
      title: EXTOLE_CLIENT_KEY
    BuiltCampaignComponentVariableResponseAsFont:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - FONT
              type: string
          type: object
      type: object
      title: FONT
    BuiltCampaignComponentVariableResponseAsGlobComponentPath:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - GLOB_COMPONENT_PATH
              type: string
          type: object
      type: object
      title: GLOB_COMPONENT_PATH
    BuiltCampaignComponentVariableResponseAsHtml:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - HTML
              type: string
          type: object
      type: object
      title: HTML
    BuiltCampaignComponentVariableResponseAsImage:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - IMAGE
              type: string
          type: object
      type: object
      title: IMAGE
    BuiltCampaignComponentVariableResponseAsInteger:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - INTEGER
              type: string
          type: object
      type: object
      title: INTEGER
    BuiltCampaignComponentVariableResponseAsIntegerList:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - INTEGER_LIST
              type: string
          type: object
      type: object
      title: INTEGER_LIST
    BuiltCampaignComponentVariableResponseAsJson:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - JSON
              type: string
          type: object
      type: object
      title: JSON
    BuiltComponentSocketResponseAsMultiSocket:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            filters:
              items:
                $ref: '#/components/schemas/SettingFilterResponse'
              type: array
            parameters:
              items:
                $ref: '#/components/schemas/BuiltCampaignComponentVariableResponse'
              type: array
            type:
              enum:
                - MULTI_SOCKET
              type: string
          type: object
      required:
        - description
        - display_name
        - filters
        - name
        - parameters
        - priority
        - tags
        - type
        - values
      type: object
      title: MULTI_SOCKET
    BuiltComponentPartnerEnumVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - PARTNER_ENUM
              type: string
            webhook_id:
              type: string
            options:
              items:
                $ref: '#/components/schemas/PartnerEnumListVariableOptionResponse'
              type: array
          type: object
      required:
        - description
        - display_name
        - name
        - options
        - priority
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
        - webhook_id
      type: object
      title: PARTNER_ENUM
    BuiltComponentPartnerEnumListVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - PARTNER_ENUM_LIST
              type: string
            webhook_id:
              type: string
            options:
              items:
                $ref: '#/components/schemas/PartnerEnumListVariableOptionResponse'
              type: array
          type: object
      required:
        - description
        - display_name
        - name
        - options
        - priority
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
        - webhook_id
      type: object
      title: PARTNER_ENUM_LIST
    BuiltCampaignComponentVariableResponseAsPersonKeyName:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - PERSON_KEY_NAME
              type: string
          type: object
      type: object
      title: PERSON_KEY_NAME
    BuiltCampaignComponentVariableResponseAsRewardSupplierId:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - REWARD_SUPPLIER_ID
              type: string
          type: object
      type: object
      title: REWARD_SUPPLIER_ID
    BuiltComponentRewardSupplierIdListVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            allowed_reward_supplier_ids:
              items:
                type: string
              type: array
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - REWARD_SUPPLIER_ID_LIST
              type: string
          type: object
      required:
        - allowed_reward_supplier_ids
        - description
        - display_name
        - name
        - priority
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
      type: object
      title: REWARD_SUPPLIER_ID_LIST
    BuiltComponentSocketResponseAsSocket:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            filters:
              items:
                $ref: '#/components/schemas/SettingFilterResponse'
              type: array
            parameters:
              items:
                $ref: '#/components/schemas/BuiltCampaignComponentVariableResponse'
              type: array
            type:
              enum:
                - SOCKET
              type: string
          type: object
      required:
        - description
        - display_name
        - filters
        - name
        - parameters
        - priority
        - tags
        - type
        - values
      type: object
      title: SOCKET
    BuiltCampaignComponentVariableResponseAsString:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - STRING
              type: string
          type: object
      type: object
      title: STRING
    BuiltCampaignComponentVariableResponseAsStringList:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - STRING_LIST
              type: string
          type: object
      type: object
      title: STRING_LIST
    BuiltComponentStringMapVariableResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            allowed_keys:
              items:
                type: string
              type: array
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - STRING_MAP
              type: string
          type: object
      required:
        - allowed_keys
        - description
        - display_name
        - name
        - priority
        - source
        - source_component_id
        - source_version
        - tags
        - type
        - values
      type: object
      title: STRING_MAP
    BuiltCampaignComponentVariableResponseAsUrl:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - URL
              type: string
          type: object
      type: object
      title: URL
    BuiltCampaignComponentVariableResponseAsWebhookId:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignComponentSettingResponseBase'
        - properties:
            description:
              type: string
            source:
              enum:
                - INHERITED
                - LOCAL
                - PARAMETER
              type: string
            source_component_id:
              type: string
            source_version:
              format: int32
              type: integer
            type:
              enum:
                - WEBHOOK_ID
              type: string
          type: object
      type: object
      title: WEBHOOK_ID
    BuiltCampaignFlowStepAppTypeResponse:
      properties:
        name:
          type: string
      type: object
    RewardRuleExpression:
      properties:
        type:
          enum:
            - JS
            - SPEL
          type: string
        value:
          type: string
      type: object
    BuiltCampaignStepResponseBase:
      properties:
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        created_date:
          $ref: '#/components/schemas/ZonedDateTime'
        data:
          items:
            $ref: '#/components/schemas/BuiltStepDataResponse'
          type: array
        enabled:
          type: boolean
        id:
          readOnly: true
          type: string
        step_builder:
          $ref: '#/components/schemas/StepBuilderInBuiltCampaignStepResponseBase'
        triggers:
          items:
            $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponse'
          type: array
        type:
          enum:
            - CONTROLLER
            - FRONTEND_CONTROLLER
            - JOURNEY_ENTRY
          type: string
        updated_date:
          $ref: '#/components/schemas/ZonedDateTime'
      type: object
    BuiltCampaignControllerActionResponse:
      discriminator:
        mapping:
          APPROVE:
            $ref: '#/components/schemas/BuiltCampaignControllerActionApproveResponse'
          CANCEL_REWARD:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionCancelRewardResponse
          CREATE_MEMBERSHIP:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionCreateMembershipResponse
          CREATIVE:
            $ref: '#/components/schemas/BuiltCampaignControllerActionCreativeResponse'
          DATA_INTELLIGENCE:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionDataIntelligenceResponse
          DECLINE:
            $ref: '#/components/schemas/BuiltCampaignControllerActionDeclineResponse'
          DISPLAY:
            $ref: '#/components/schemas/BuiltCampaignControllerActionDisplayResponse'
          EARN_REWARD:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionEarnRewardResponse
          EMAIL:
            $ref: '#/components/schemas/BuiltCampaignControllerActionEmailResponse'
          EXPRESSION:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionExpressionResponse
          FIRE_AS_PERSON:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionFireAsPersonResponse
          FULFILL_REWARD:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionFulfillRewardResponse
          INCENTIVIZE:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionIncentivizeResponse
          INCENTIVIZE_STATUS_UPDATE:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionIncentivizeStatusUpdateResponse
          REDEEM_REWARD:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionRedeemRewardResponse
          REMOVE_MEMBERSHIP:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionRemoveMembershipResponse
          REVOKE_REWARD:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionRevokeRewardResponse
          SCHEDULE:
            $ref: '#/components/schemas/BuiltCampaignControllerActionScheduleResponse'
          SHARE_EVENT:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionShareEventResponse
          SIGNAL:
            $ref: '#/components/schemas/BuiltCampaignControllerActionSignalResponse'
          SIGNAL_V1:
            $ref: '#/components/schemas/BuiltCampaignControllerActionSignalV1Response'
          STEP_SIGNAL:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerActionStepSignalResponse
          WEBHOOK:
            $ref: '#/components/schemas/BuiltCampaignControllerActionWebhookResponse'
        propertyName: action_type
      oneOf:
        - title: APPROVE
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerActionApproveResponse
        - title: CANCEL_REWARD
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerActionCancelRewardResponse
        - title: CREATE_MEMBERSHIP
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerActionCreateMembershipResponse
        - title: CREATIVE
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerActionCreativeResponse
        - title: DATA_INTELLIGENCE
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerActionDataIntelligenceResponse
        - title: DECLINE
          allOf:
            - $ref: >-
[...]
